﻿<?php
	/*
	 * THIS WIDGET WAS CREATED BY SILVERTOAD LTD.
	 *
	 */
	 
class SupportForm extends Widget {
	
	static $title = "Support Form";
	static $cmsTitle = "Honeycomb Support Form";
	static $description = "Displays the Honeycomb Support Form.";
	
	static $db = array(
		'Mailto' => 'Varchar(100)',
		'SubmitText' => 'Text'
	);
	
	function getCMSFields() {
		// adds the 2 new form fields
		/*$fields->addFieldToTab(
			"Root.Content.OnSubmission",
			new TextField('Mailto', 'Email submissions to')
		);
		$fields->addFieldToTab(
			"Root.Content.OnSubmission",
			new TextField('SubmitText', 'Text on Submission')
		);
		
		// displays the above added fields
		return $fields;*/
		
		// Adds CMS fields
		return new FieldSet (
			new TextField('Mailto', 'Email submissions to'),
			new TextField('SubmitText', 'Text on Submission')
		);
	}

}
class SupportForm_Controller extends Widget_Controller {
	
	// SUPPORT FORM CODE
	function SupportForm() {
		// Create Fields
		$fields = new FieldSet(
			new TextField('Name', 'Name*'),
			new TextField('Company', 'Company*'),
			new EmailField('Email', 'Email*'),
			new TextareaField('Problem', 'Problem / Technical Issue'),
			new TextField('Telephone', 'Telephone*')
		);
		
		// Create Action
		$actions = new FieldSet(
			new FormAction('SendSupportForm', 'Submit')
		);
		
		// Create Validators
		$validator = new RequiredFields(
			'Name', 'Company', 'Email', 'Telephone'
		);
		
		return new Form($this, 'SupportForm', $fields, $actions, $validator);
	}
	
	// SUPPORT FORM CODE SUBMISSION
	function SendSupportForm($data, $form) {
		// Set data
		$From = $data['Email'];
		$To = $this->Mailto;
		$Subject = "Website Support message";
		$email = new Email($From, $To, $Subject);
		
		// Set template
		$email->setTemplate('SupportEmail');
		
		// Populate template
		$email->populateTemplate($data);
		
		//Send mail
		$email->send();
		
		//Return to submitted message
		//Director::redirect(
		//	$this->Link("?success=1")
		//);
		Director::redirect(
			'?success=1'
		);
	}
	
	// Redirects back to the page and displays the success message
	function Success() {
		return isset($_REQUEST['success']) && $_REQUEST['success'] == "1";
	}

	function init() {
		parent::init();
		
		// Is supposed to switch off the prototype form validation
		Validator::set_javascript_validation_handler('none');   
		// Requirements::javascript("http://ajax.googleapis.com/ajax/libs/jquery/1.5/jquery.min.js");
		Requirements::javascript("sapphire/thirdparty/jquery/jquery.js");
		Requirements::javascript("http://ajax.microsoft.com/ajax/jquery.validate/1.8/jquery.validate.min.js");
			 
		Requirements::customScript('
			jQuery(document).ready(function() {
				jQuery("#Form_SupportForm").validate({
					rules: {
						Name: "required",
						Email: {
							required: true,
							email: true
						},
						Comments: {
							required: true,
							minlength: 20
						}
					},
					messages: {
						Name: "I would really love to know your name",
						Email: "It is quite important that you give me your actual email address so I can send you messages",
						Comments: "What are you thinking? Tell me"
					}
				});
			});
		');
	}
}